"IAL"

*
* Original Source File Name: d:\ial\procs\i8085_ip.s
*

        SEARCH_LIMIT     5
        DEFAULT_WIDTH    20
        MAPPED_WIDTH     20
        LABEL_TITLE      "8085 Mnemonic"
        BASE_TITLE       "     hex"
VAR_0034        VARIABLE 000000000H
VAR_0036        VARIABLE 000000200H
VAR_0038        VARIABLE 000000200H
VAR_003A        VARIABLE 000000200H
VAR_003C        VARIABLE 000000200H
VAR_003E        VARIABLE 000000200H
VAR_0040        VARIABLE 000000200H
VAR_0042        VARIABLE 000000200H
VAR_0044        VARIABLE 000000200H
CONST_0046      CONSTANT 00000FFFFH
STR_000C        ASCII "unknown"
STR_0010        ASCII "memory write"
STR_0017        ASCII "memory read"
STR_001D        ASCII "i/o write"
STR_0022        ASCII "i/o read"
STR_0027        ASCII "interrupt ack"
STR_002E        ASCII "halt"
FMT_0031        FORMAT 16,HEX,4
FMT_0033        FORMAT 8,HEX,2

ENTRY_POINT
    SET VAR_0042,0
    SET RETURN_FLAGS,0
    LOAD INITIAL_ADDRESS
    STORE VAR_0034
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0012
    IF TASK = 3 THEN GOTO LABEL_0016
    IF TASK = 4 THEN GOTO LABEL_0016
    IF TASK = 5 THEN GOTO LABEL_0016
    OUTPUT "Illegal Task Request"
    ABORT

LABEL_0012
    OUTPUT "Data error"
    ABORT

LABEL_0014
    OUTPUT "Illegal Opcode"
    ABORT

LABEL_0016
    LOAD INPUT_STATUS
    AND 11
    IF 3,0 = 3 THEN GOTO LABEL_0034
    POSITION REL,2
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_0033    * 8,HEX,2
    POSITION REL,1
    LOAD INPUT_STATUS
    AND 11
    CASE_OF 3,0
        OUTPUT STR_000C    * "unknown"
        OUTPUT STR_0010    * "memory write"
        OUTPUT STR_0017    * "memory read"
        OUTPUT STR_000C    * "unknown"
        OUTPUT STR_000C    * "unknown"
        OUTPUT STR_0010    * "memory write"
        OUTPUT STR_0017    * "memory read"
        OUTPUT STR_000C    * "unknown"
        OUTPUT STR_002E    * "halt"
        OUTPUT STR_001D    * "i/o write"
        OUTPUT STR_0022    * "i/o read"
        OUTPUT STR_0027    * "interrupt ack"
        OUTPUT STR_002E    * "halt"
        OUTPUT STR_001D    * "i/o write"
        OUTPUT STR_0022    * "i/o read"
        OUTPUT STR_0027    * "interrupt ack"
    CASE_END
    RETURN

LABEL_0034
    SET RETURN_FLAGS,1
    LOAD INPUT_DATA
    CASE_OF 7,6
        GOTO LABEL_003C
        GOTO LABEL_008D
        GOTO LABEL_0097
        GOTO LABEL_00A4
    CASE_END

LABEL_003C
    CASE_OF 2,0
        GOTO LABEL_0046
        GOTO LABEL_0050
        GOTO LABEL_005B
        GOTO LABEL_006F
        GOTO LABEL_0076
        GOTO LABEL_0079
        GOTO LABEL_007C
        GOTO LABEL_0081
    CASE_END

LABEL_0046
    IF 3,3 = 1 THEN GOTO LABEL_0014
    CASE_OF 5,4
        OUTPUT "NOP"
        GOTO LABEL_0014
        OUTPUT "RIM"
        OUTPUT "SIM"
    CASE_END
    RETURN

LABEL_0050
    IF 3,3 = 0 THEN GOTO LABEL_0056
    OUTPUT "DAD  "
    CALL LABEL_0123
    RETURN

LABEL_0056
    OUTPUT "LXI  "
    CALL LABEL_0123
    OUTPUT ","
    CALL LABEL_0131
    RETURN

LABEL_005B
    IF 5,5 = 0 THEN GOTO LABEL_0068
    CASE_OF 4,3
        OUTPUT "SHLD"
        OUTPUT "LHLD"
        OUTPUT "STA "
        OUTPUT "LDA "
    CASE_END
    STORE VAR_0044
    POSITION REL,1
    CALL LABEL_012F
    RETURN

LABEL_0068
    CASE_OF 3,3
        OUTPUT "STAX"
        OUTPUT "LDAX"
    CASE_END
    POSITION REL,1
    CALL LABEL_0123
    RETURN

LABEL_006F
    CASE_OF 3,3
        OUTPUT "INX"
        OUTPUT "DCX"
    CASE_END
    POSITION REL,2
    CALL LABEL_0123
    RETURN

LABEL_0076
    OUTPUT "INR  "
    CALL LABEL_010D
    RETURN

LABEL_0079
    OUTPUT "DCR  "
    CALL LABEL_010D
    RETURN

LABEL_007C
    OUTPUT "MVI  "
    CALL LABEL_010D
    OUTPUT ","
    CALL LABEL_0164
    RETURN

LABEL_0081
    CASE_OF 5,3
        OUTPUT "RLC"
        OUTPUT "RRC"
        OUTPUT "RAL"
        OUTPUT "RAR"
        OUTPUT "DAA"
        OUTPUT "CMA"
        OUTPUT "STC"
        OUTPUT "CMC"
    CASE_END
    POSITION REL,2
    RETURN

LABEL_008D
    IF 7,0 <> 000000076H THEN GOTO LABEL_0092
    OUTPUT "HLT"
    RETURN

LABEL_0092
    OUTPUT "MOV  "
    CALL LABEL_010D
    OUTPUT ","
    CALL LABEL_0118
    RETURN

LABEL_0097
    CASE_OF 5,3
        OUTPUT "ADD"
        OUTPUT "ADC"
        OUTPUT "SUB"
        OUTPUT "SBB"
        OUTPUT "ANA"
        OUTPUT "XRA"
        OUTPUT "ORA"
        OUTPUT "CMP"
    CASE_END
    POSITION REL,2
    CALL LABEL_0118
    RETURN

LABEL_00A4
    CASE_OF 2,0
        GOTO LABEL_00AF
        GOTO LABEL_00B2
        GOTO LABEL_00BF
        GOTO LABEL_00C4
        GOTO LABEL_00D8
        GOTO LABEL_00DD
        GOTO LABEL_00E9
        GOTO LABEL_00F6
    CASE_END
    GOTO LABEL_0014

LABEL_00AF
    OUTPUT "R"
    CALL LABEL_0102
    RETURN

LABEL_00B2
    IF 3,3 = 1 THEN GOTO LABEL_00B8
    OUTPUT "POP  "
    CALL LABEL_0123
    RETURN

LABEL_00B8
    CASE_OF 5,4
        OUTPUT "RET  "
        GOTO LABEL_0014
        OUTPUT "PCHL "
        OUTPUT "SPHL "
    CASE_END
    RETURN

LABEL_00BF
    OUTPUT "J"
    CALL LABEL_0102
    POSITION REL,2
    CALL LABEL_012F
    RETURN

LABEL_00C4
    CASE_OF 5,3
        GOTO LABEL_00CF
        GOTO LABEL_0014
        GOTO LABEL_00D2
        GOTO LABEL_00D2
        OUTPUT "XTHL "
        OUTPUT "XCHG "
        OUTPUT "DI   "
        OUTPUT "EI   "
    CASE_END
    RETURN

LABEL_00CF
    OUTPUT "JMP  "
    CALL LABEL_012F
    RETURN

LABEL_00D2
    CASE_OF 3,3
        OUTPUT "OUT  "
        OUTPUT "IN   "
    CASE_END
    CALL LABEL_0164
    RETURN

LABEL_00D8
    OUTPUT "C"
    CALL LABEL_0102
    POSITION REL,2
    CALL LABEL_012F
    RETURN

LABEL_00DD
    IF 3,3 = 0 THEN GOTO LABEL_00E6
    IF 5,3 <> 1 THEN GOTO LABEL_0014
    OUTPUT "CALL "
    CALL LABEL_012F
    RETURN

LABEL_00E6
    OUTPUT "PUSH "
    CALL LABEL_0123
    RETURN

LABEL_00E9
    CASE_OF 5,3
        OUTPUT "AD"
        OUTPUT "AC"
        OUTPUT "SU"
        OUTPUT "SB"
        OUTPUT "AN"
        OUTPUT "XR"
        OUTPUT "OR"
        OUTPUT "CP"
    CASE_END
    OUTPUT "I  "
    CALL LABEL_0164
    RETURN

LABEL_00F6
    OUTPUT "RST  "
    CASE_OF 5,3
        OUTPUT "0"
        OUTPUT "1"
        OUTPUT "2"
        OUTPUT "3"
        OUTPUT "4"
        OUTPUT "5"
        OUTPUT "6"
        OUTPUT "7"
    CASE_END
    RETURN

LABEL_0102
    CASE_OF 5,3
        OUTPUT "NZ"
        OUTPUT "Z "
        OUTPUT "NC"
        OUTPUT "C "
        OUTPUT "PO"
        OUTPUT "PE"
        OUTPUT "P "
        OUTPUT "M "
    CASE_END
    RETURN

LABEL_010D
    CASE_OF 5,3
        OUTPUT "B"
        OUTPUT "C"
        OUTPUT "D"
        OUTPUT "E"
        OUTPUT "H"
        OUTPUT "L"
        OUTPUT "M"
        OUTPUT "A"
    CASE_END
    RETURN

LABEL_0118
    CASE_OF 2,0
        OUTPUT "B"
        OUTPUT "C"
        OUTPUT "D"
        OUTPUT "E"
        OUTPUT "H"
        OUTPUT "L"
        OUTPUT "M"
        OUTPUT "A"
    CASE_END
    RETURN

LABEL_0123
    CASE_OF 5,4
        OUTPUT "B"
        OUTPUT "D"
        OUTPUT "H"
        OUTPUT "SP"
    CASE_END
    IF 7,4 <> 15 THEN RETURN
    POSITION REL,-2
    OUTPUT "PSW"
    RETURN

LABEL_012F
    SET VAR_003E,0
    GOTO LABEL_0132

LABEL_0131
    SET VAR_003E,1

LABEL_0132
    CALL LABEL_016F
    STORE VAR_0036
    LOAD INPUT_ERROR
    STORE VAR_003A
    LOAD INPUT_STATUS
    AND 11
    STORE VAR_003C
    CALL LABEL_016F
    STORE VAR_0038
    ROTATE LEFT,8
    INCLUSIVE_OR VAR_0036
    AND CONST_0046
    STORE VAR_0040
    LOAD INPUT_STATUS
    AND 11
    IF 3,0 = 3 THEN GOTO LABEL_014A
    IF VAR_003C = 3 THEN GOTO LABEL_014A
    IF INPUT_ERROR = 0 THEN GOTO LABEL_014D

LABEL_014A
    OUTPUT "**"
    SET VAR_003E,1
    GOTO LABEL_0152

LABEL_014D
    IF VAR_003E = 0 THEN GOTO LABEL_0152
    LOAD VAR_0038
    OUTPUT ACCUMULATOR,FMT_0033    * 8,HEX,2

LABEL_0152
    IF VAR_003C = 3 THEN GOTO LABEL_0158
    IF VAR_003A = 0 THEN GOTO LABEL_015A

LABEL_0158
    OUTPUT "**"
    RETURN

LABEL_015A
    IF VAR_003E = 0 THEN GOTO LABEL_0160
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0033    * 8,HEX,2
    RETURN

LABEL_0160
    LOAD VAR_0040
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0031    * 16,HEX,4
    RETURN

LABEL_0164
    CALL LABEL_016F
    LOAD INPUT_STATUS
    AND 11
    IF 3,0 <> 3 THEN GOTO LABEL_016C
    OUTPUT "**"
    RETURN

LABEL_016C
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_0033    * 8,HEX,2
    RETURN

LABEL_016F
    INCREMENT VAR_0034
    LOAD VAR_0042
    CASE_OF 0,0
        INPUT ABS,VAR_0034
        INPUT REL,VAR_0034
    CASE_END
    LOAD INPUT_DATA
    RETURN
